/*
 * Copyright 2008-2011 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.nominanuda.hyperapi;

import static com.nominanuda.io.IOHelper.IO;

import java.io.IOException;

import org.apache.http.HttpEntity;

public class ByteArrayEntityDecoder extends AbstractEntityDecoder<byte[]> {

	public ByteArrayEntityDecoder() {
		super(byte[].class, ANY_CONTENT_TYPE);
	}

	@Override
	protected byte[] decodeInternal(AnnotatedType p, HttpEntity entity) throws IOException {
		return IO.readAndClose(entity.getContent());
	}

}
